dhtmlxScheduler with Vue.js

You should be familiar with the basic concepts and patterns of Vue to use this documentation. If you are not, please refer to the Vue 3 documentation for a getting-started tutorial.

DHTMLX Scheduler is compatible with Vue. You can check the corresponding example on GitHub: DHTMLX Scheduler with Vue Demo.

Creating a project

Before you start to create a new project, install Node.js.

To create a Vue project, run the following command:

npm create vue@latest

This command will install and execute create-vue, the official Vue project scaffolding tool. Check the details in the Vue.js Quick Start.

Installation of dependencies

Next you should go to the app directory. Let's name our project scheduler-vue and run:

cd scheduler-vue

After that you should install dependencies and start the dev server. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

You should now have your Vue project running on http://localhost:5173.

Scheduler Vue.js app running

Creating Scheduler

Now we should get the DHTMLX Scheduler code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Scheduler package.

Step 1. Package installation

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Scheduler, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-scheduler
  • for yarn:
yarn add @dhx/trial-scheduler

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation

Now we should create a Vue component, to add a Scheduler into the application. Let's create a new file in the src/components/ directory and name it Scheduler.vue.

Importing source files

Open the newly created Scheduler.vue file and import Scheduler source files. Note that:

  • if you've installed the Scheduler package from a local folder, your import paths will look like this:

Scheduler.vue

import { Scheduler } from "dhtmlx-scheduler";<style>
  @import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
</style>
  • if you've chosen to install the trial version, the import paths should be as in:

Scheduler.vue

import { Scheduler } from "@dhx/trial-scheduler";<style>
  @import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
</style>

In this tutorial we will use the trial version of Scheduler.

Setting the container and adding Scheduler

To display Scheduler on the page, we need to set the container to render the component inside. Check the code below:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 9, 6), "week");
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

To make the Scheduler container occupy the entire space of the body, you need to remove the default styles from the main.css file located in the src/assets folder and add the following one:

src/assets/main.css

#app {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Step 3. Adding Scheduler into the app

Now it's time to add the component into our app. Open src/App.vue and use the Scheduler component instead of the default content by inserting the code below:

src/App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
 
export default {
  components: { Scheduler },
};
</script>   <template> <Scheduler/> </template>

After that, when we start the app, we should see an empty Scheduler on a page:

Scheduler Vue init

Step 4. Providing Data

To add data into the Scheduler, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

We should pass props (our data) to a Scheduler component in App.vue:

App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
import { getData } from "./data";
 
export default {
  components: { Scheduler },
  data() {
    return {
      events: getData(),
    };
  },
};
</script>   <template> <Scheduler :events="events" /> </template>

And then use props in the scheduler.parse() method in the Scheduler component:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  props: ["events"],
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 5, 10), "week");
    scheduler.parse(this.events);
 
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

Now, if you reopen the app page, you should see a Scheduler with events:

Scheduler Vue events

Step 5. Saving Data

To capture changes made in the Scheduler, you can use the dataProcessor handler that lets you
"communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxScheduler accepts Promise response from the handler, so your Scheduler will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

If your service changes the event id after creating a new record (which it usually does), make sure that your Promise returns an object with {id: databaseId} or {tid: databaseId} as a result, so Scheduler could apply the new database id to the record. Get more information about the server side.

Well, Vue Scheduler is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks

Pay attention that Scheduler doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Back to top

dhtmlxScheduler with React

You should be familiar with the basic concepts and patterns of React to use this documentation. If you are not, please refer to the React documentation for a getting-started tutorial.

DHTMLX Scheduler is compatible with React. You can check the corresponding example on GitHub: DHTMLX Scheduler with React Demo.

Creating a project

Before you start to create a new project, install Node.js.

You can create a basic React project using the following command:

npx create-vite my-react-scheduler-app --template react

Installation of dependencies

Next you should go to the app directory. Let's call our project my-react-scheduler-app and run:

cd my-react-scheduler-app

After that you should install dependencies and start the dev server. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

You should now have your React project running on http://localhost:5173.

Scheduler React app running

Creating Scheduler

Now we should get the DHTMLX Scheduler code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Scheduler package.

Step 1. Package installation

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Scheduler, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-scheduler
  • for yarn:
yarn add @dhx/trial-scheduler

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation

Now we should create a React component, to add a Scheduler into the application. Let's create the src/components/Scheduler folder. Here we'll create the Scheduler.jsx, Scheduler.css and index.js files.

We need to create the Scheduler.css file and add styles for the scheduler-container:

src/components/Scheduler/Scheduler.css

.scheduler-container {
    height: 100vh;
    width: 100vw;
}

To make the Scheduler container occupy the entire space of the body, you need to remove the default styles from the App.css file located in the src folder and add the following one:

#root {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

And add the index.js file with the following content:

src/components/Scheduler/index.js

import Scheduler from './Scheduler';
import './Scheduler.css';
export default Scheduler;

Importing source files

Open the newly created Scheduler.jsx file and import Scheduler source files. Note that:

  • if you've installed the Scheduler package from a local folder, your import paths will look like this:

Scheduler.jsx

import { Scheduler } from 'dhtmlx-scheduler';
import 'dhtmlx-scheduler/codebase/dhtmlxscheduler.css';
  • if you've chosen to install the trial version, the import paths should be as in:

Scheduler.jsx

import { Scheduler } from '@dhx/trial-scheduler';
import '@dhx/trial-scheduler/codebase/dhtmlxscheduler.css';

In this tutorial we will use the trial version of Scheduler.

Setting the container and adding Scheduler

To display Scheduler on the page, we need to set the container to render the component inside. Create the Scheduler.jsx file with the following code:

src/components/Scheduler/Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView( ) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

Step 3. Adding Scheduler into the app

Now it's time to add the component into our app. Open src/App.jsx and use the Scheduler component instead of the default content by inserting the code below:

src/App.jsx

import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler/>
        </div>
    );
}
export default App;

After that, when we start the app, we should see an empty Scheduler on a page:

Scheduler React init

Step 4. Providing Data

To add data into the Scheduler, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

And we should pass props (our data) to a Scheduler component in App.jsx:

App.jsx

import { getData } from "./data.js";
import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler events={getData()}/>
        </div>
    );
}
export default App;

And use props in the scheduler.parse() method in the Scheduler component:

Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView({events}) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        scheduler.parse(events);
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

Now, if you reopen the app page, you should see a Scheduler with events:

Scheduler React events

Step 5. Saving Data

To capture changes made in the Scheduler, you can use the dataProcessor handler that lets you
"communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxScheduler accepts Promise response from the handler, so your Scheduler will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

If your service changes the event id after creating a new record (which it usually does), make sure that your Promise returns an object with {id: databaseId} or {tid: databaseId} as a result, so Scheduler could apply the new database id to the record. Get more information about the server side.

Well, React Scheduler is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks

Pay attention that Scheduler doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Back to top

dhtmlxScheduler with Angular

You should be familiar with the basic concepts and patterns of Angular to use this documentation. If you are not, please refer to the Angular documentation for a getting-started tutorial.

DHTMLX Scheduler is compatible with Angular. You can check the corresponding example on GitHub: DHTMLX Scheduler with Angular Demo.

Creating a project

Before you start to create a new project, install Angular CLI and Node.js. Then run the following command:

ng new my-angular-scheduler-app

The above command will install all the necessary tools and dependencies, so you don't need any additional commands.

Installation of dependencies

After that go to the app directory by running:

cd my-angular-scheduler-app

Then run the app with one of the following commands:

yarn start

or

npm start

Now the app should be running on http://localhost:4200.

Scheduler with Angular

Creating Scheduler

Now we should get the DHTMLX Scheduler code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Scheduler package.

Step 1. Package installation

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Scheduler, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-scheduler
  • for yarn:
yarn add @dhx/trial-scheduler

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation

Now we should create a component to add a Scheduler into the application. Let's create the scheduler folder in the src/app/ directory, add new files into it and call them scheduler.component.ts, scheduler.component.css and scheduler.component.html.

The newly created scheduler.component.html file inside the scheduler folder will contain the template for the scheduler. Let's add the following lines of code into it:

scheduler/scheduler.component.html

<div #scheduler_here class="dhx_cal_container" style="width: 100%; height:100vh">
   <div class="dhx_cal_navline">
       <div class="dhx_cal_prev_button"></div>
       <div class="dhx_cal_next_button"></div>
       <div class="dhx_cal_today_button"></div>
       <div class="dhx_cal_date"></div>
       <div class="dhx_cal_tab" data-tab="day"></div>
       <div class="dhx_cal_tab" data-tab="week"></div>
       <div class="dhx_cal_tab" data-tab="month"></div>
   </div>
   <div class="dhx_cal_header"></div>
   <div class="dhx_cal_data"></div>
</div>

We'll declare scheduler styles in a separate file named scheduler.component.css. The default styles can look like this:

scheduler/scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
:host {
   display: block;
   position: relative;
   height: 100%;
   width: 100%;
}

To make the Scheduler container occupy the entire space of the body, you need to add the following styles to the styles.css file located in the src folder:

src/styles.css

html,
body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Importing source files

Open the scheduler.component.ts and scheduler.component.css files and import Scheduler source files. Note that:

  • if you've installed the Scheduler package from a local folder, your import paths will look like this:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from 'dhtmlx-scheduler';

scheduler.component.css

@import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • if you've chosen to install the trial version, the import paths should be as in:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from '@dhx/trial-scheduler';

scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

In this tutorial we will use the trial version of Scheduler.

Setting the container and adding Scheduler

To display Scheduler on the page, we need to set the container to render the component inside. Use the code below:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

In the above code we've used the ngOnInit() method of Angular and also specified the ngOnDestroy() method that contains the scheduler.destructor() call to clear the component when it is no longer needed.

Step 3. Adding Scheduler into the app

Now it's time to add the component into our app. Open src/app/app.component.ts and use the Scheduler Component instead of the default content by inserting the code below:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  template: `<scheduler></scheduler>`,
})
export class AppComponent {
  name = '';
}

Then create the app.module.ts file in the src/app/ directory and insert SchedulerComponent as provided below:

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { SchedulerComponent } from "./scheduler/scheduler.component";
 
@NgModule({
  declarations: [AppComponent, SchedulerComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

The last step is to open the src/main.ts file and replace the existing code with the following one:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

After that, when we start the app, we should see an empty Scheduler on a page.

Adding Scheduler into an app

Step 4. Providing Data

To add data loading to the Angular Scheduler, you need to add an event service. But before that, let's define the event model.

For creating the event model, run the following command:

ng generate class models/event --skip-tests

In the newly created event.ts file inside the models folder, we will add the following lines of code:

models/event.ts

export class Event {
    id!:  number;
    start_date!: string;
    end_date!: string;
    text!: string;
}

Now let's create an event service. A service is a class that will be responsible for creating a specific event. Services in Angular can be injected by using the Dependency Injection mechanism. They can include data, functions or some features necessary for the application. You need to create a data service that will be used to provide the scheduler with events.

For creating an event service, run the following command:

ng generate service services/event --flat --skip-tests

In the newly created event.service.ts file inside the services folder it is required to add the following lines of code:

services/event.service.ts

import { Injectable } from '@angular/core';
import { Event } from "../models/event";
 
@Injectable()
export class EventService {
    get(): Promise<Event[]>{
        return Promise.resolve([
            { id: 1, start_date: "2023-05-16 09:00", end_date: "2023-05-16 13:00", 
                text: "Event 1" },
            { id: 2, start_date: "2023-05-18 10:00", end_date: "2023-05-18 14:00", 
                text: "Event 2" },
        ]);
    }
}

We've added the @Injectable() decorator to our service. It marks a class as available for an injector to instantiate. We'll inject it into our component further.

Currently, the get() method returns a resolved promise with hardcoded data. However, you can load data from the server side and also return a promise. The scheduler component is supposed to use EventService to get events. To enable this, let's add EventService to the component. First, import the necessary module for the service in scheduler.component.ts:

scheduler.component.ts

import {EventService} from "../services/event.service";

You should also specify EventService as a provider in the @Component decorator:

scheduler.component.ts

@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})

Now, every time a new SchedulerComponent is initialized, a fresh instance of the service will be created. The service should be prepared to be injected into the component. For this purpose, add the following constructor to the SchedulerComponent class:

scheduler.component.ts

constructor(private eventService: EventService){}

Modify the ngOnInit() function:

  • set the data format for loading events (XML in this case)
  • call the services to get the function and then wait for a response to put the data to the scheduler

scheduler.component.ts

scheduler.config.date_format = "%Y-%m-%d %H:%i";
scheduler.init(this.schedulerContainer.nativeElement, new Date(2024, 9, 7));
this.eventService.get()
    .then((data) => {
         scheduler.parse(data);
    });

The complete code of the scheduler.components.ts file will look like this:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
import {EventService} from "../services/event.service";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ['scheduler.component.css'],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
  constructor(private eventService: EventService) { }
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.config.date_format = "%Y-%m-%d %H:%i";
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this.eventService.get().then((data) => {scheduler.parse(data);});
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

Now, if you reopen the app page, you should see a Scheduler with events.

Scheduler with Angular events

Step 5. Saving Data

To capture changes made in the Scheduler, you can use a dataProcessor handler that lets you "communicate" with the server-side backend. The handler can be declared either as a function or a router object. dhtmlxScheduler accepts Promise response from the handler, so your Scheduler will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes, like this:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

If your service changes the event id after creating a new record (which it usually does), make sure that your Promise returns an object with {id: databaseId} or {tid: databaseId} as a result, so that Scheduler could apply the new database id to the record. Get more information about the server side.

Well, Angular Scheduler is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks

Pay attention that Scheduler doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Back to top

dhtmlxScheduler with Svelte

You should be familiar with the basic concepts and patterns of Svelte to use this documentation. If you are not, please refer to the Svelte documentation for a getting-started tutorial.

DHTMLX Scheduler is compatible with Svelte. You can check the corresponding example on GitHub: DHTMLX Scheduler with Svelte Demo.

Creating a project

Before you start to create a new project, install Vite (optional) and Node.js.

To create a Svelte project we will use Svelte with Vite and run the following command:

npm create vite@latest

Check the details in the related article.

Installation of dependencies

Next you should go to the app directory. Let's name our project scheduler-svelte and choose the svelte option, then run:

cd scheduler-svelte

After that you should install dependencies and run the app. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

You should now have your Svelte project running on http://localhost:5173.

Scheduler Svelte app running

Creating Scheduler

Now we should get the DHTMLX Scheduler code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Scheduler package.

Step 1. Package installation

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Scheduler, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-scheduler
  • for yarn:
yarn add @dhx/trial-scheduler

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation

Now we should create a Svelte component, to add a Scheduler into the application. Let's create a new file in the src/ directory and name it Scheduler.svelte.

Importing source files

Open the newly created Scheduler.svelte file and import Scheduler source files. Note that:

  • if you've installed the Scheduler package from a local folder, your import paths will look like this:

Scheduler.svelte

import { Scheduler } from "dhtmlx-scheduler";
import "dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • if you've chosen to install the trial version, the import paths should be as in:

Scheduler.svelte

import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

In this tutorial we will use the trial version of Scheduler.

Setting the container and adding Scheduler

To display Scheduler on the page, we need to set the container to render the component inside. Check the code below:

Scheduler.svelte

<script>
    import { onMount } from "svelte";
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.init(container, new Date(2023, 9, 6), "week");
 
        return () => scheduler.destructor();
    });
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

To make the Scheduler container occupy the entire space of the body, you need to remove the default styles from the app.css file located in the src/ folder and add the following one:

src/app.css

body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Step 3. Adding Scheduler into the app

Now it's time to add the component into our app. Open src/App.svelte and use the Scheduler component instead of the default content by inserting the code below:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
</script>   <Scheduler/>

After that, when we start the app, we should see an empty Scheduler on a page:

Scheduler Svelte init

Step 4. Providing Data

To add data into the Scheduler, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

And we should pass props (our data) to a Scheduler component in App.svelte:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
  import { getData } from "./data.js";
</script>   <Scheduler data={getData()} />

And use props in the scheduler.parse() method in the Scheduler component:

Scheduler.svelte

<script>
    import { onMount } from "svelte";
 
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css"
    export let data;  
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace"
        scheduler.init(container, new Date(2024, 5, 10), "week");
 
        return () => scheduler.destructor();
    });
 
    $: scheduler?.parse(data);
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

Now, if you reopen the app page, you should see a Scheduler with events:

Scheduler Svelte events

Step 5. Saving Data

To capture changes made in the Scheduler, you can use the dataProcessor handler that lets you
"communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxScheduler accepts Promise response from the handler, so your Scheduler will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

If your service changes the event id after creating a new record (which it usually does), make sure that your Promise returns an object with {id: databaseId} or {tid: databaseId} as a result, so Scheduler could apply the new database id to the record. Get more information about the server side.

Well, Svelte Scheduler is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks

Pay attention that Scheduler doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Back to top